//+------------------------------------------------------------------+
//|                                                TestScrollbar.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
//---
#property indicator_separate_window //   
#property indicator_plots 0         //   
//---
#define LIST_SIZE 71                //       
//---      
#include <Canvas\Canvas.mqh>
CCanvas canvas;
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
//---   
int               subwindow_number              =WRONG_VALUE;                    //  
int               subwindow_height              =0;                              //  
string            subwindow_shortname           ="TestScrollbar";                //   
string            prefix                        =subwindow_shortname+"_";        //   
int               chart_width                   =0;                              //  
int               chart_height                  =0;                              //  
int               chart_y_offset                =0;                              //      
//---  
string            canvas_name                   =prefix+"canvas";                //  
color             canvas_background_color       =C'20,20,20';                    //   
ENUM_COLOR_FORMAT color_format                  =COLOR_FORMAT_XRGB_NOALPHA;      //  - 
//---  
int               list_height                   =0;                              //  
int               text_height                   =0;                              //  
int               font_size                     =15;                             //  
string            font_name                     ="Calibri";                      // 
double            line_size                     =100/LIST_SIZE;                  //      
//---   : 
string            scrollbar_thumb_name          =prefix+"scrollbar_thumb";       //  -
int               scrollbar_thumb_x1            =0;                              //  x1
int               scrollbar_thumb_y1            =0;                              //  y1
int               scrollbar_thumb_x2            =0;                              //  x2
int               scrollbar_thumb_y2            =0;                              //  y2
double            scrollbar_thumb_y_percent     =0.0;                            //    Y   
int               scrollbar_thumb_width         =9;                              // 
int               scrollbar_thumb_height        =0;                              // 
bool              scrollbar_thumb_clicked       =false;                          //  (     )
color             scrollbar_thumb_color         =clrSilver;                      //  
color             scrollbar_thumb_color_on_hover=clrDimGray;                     //     
color             scrollbar_thumb_color_on_click=clrSlateGray;                   //    
//---   : 
string            scrollbar_background_name     =prefix+"scrollbar_background";  //  -
int               scrollbar_background_width    =9;                              //  
color             scrollbar_background_color    =C'50,50,50';                    //  
//---   : 
int               scrollbar_fix_point           =0;                              // Y-    
int               scrollbar_fix_point_y_offest  =0;                              //    Y      
//---    (/)
bool              mouse_button_state=false;
//---     
color             symbol_property_colors[];                                      //  
string            symbol_property_values[];                                      // 
//---    
string symbol_propety_names[LIST_SIZE]=
  {
   "    ",
   "       ",
   "       ",
   "   ",
   "   ",
   "   ",
   "  ",
   "   ",
   "   ",
   "  ",
   "     ",
   "   ",
   "  ",
   "     (   )",
   "     (   )",
   "          Stop ",
   "    ( )",
   "  ",
   "  ",
   "     ",
   "    ",
   "    ",
//---
   "Bid -    ",
   " Bid  ",
   " Bid  ",
   "Ask -    ",
   " Ask  ",
   " Ask  ",
   "Last -   ",
   " Last  ",
   " Last  ",
   "  ",
   "     ",
   "     ",
   "  ",
   "  ",
   "    ",
   "    ",
   "      ",
   "            ",
   "   ",
   "   ",
   "  -           (1 )",
   "   ",
   "     ",
   "     ",
   "    Limit ",
   "    Stop ",
   "    Stop Limit ",
   "     ",
   "    ",
   "   ",
   "       ",
   "       ",
   "  ",
   "  ",
   "  ",
   "    ",
   "     ",
   "     ",
//---
   "  ",
   " ",
   ",     ",
   "  ",
   "  ",
   "          (ISIN)",
   "   ",
//---
   "       ",
   "       ",
   "         ",
   "   "
  };
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---     
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
//---   
   IndicatorSetString(INDICATOR_SHORTNAME,subwindow_shortname);
//---        
   ArrayResize(symbol_property_colors,LIST_SIZE);
   ArrayResize(symbol_property_values,LIST_SIZE);
//---   
   SetSubwindowProperties();
//---      
   canvas.FontSet(font_name,font_size,FW_NORMAL);
//---   ()   
   text_height=canvas.TextHeight("A")-1;
//---    
   list_height=text_height*LIST_SIZE;
//---    
   AddCanvas();
//---   :   
   AdjustScrollbarBackground();
   AdjustScrollbarThumb();
//---    
   ShowSymbolInfo();
//---  
   ChartRedraw();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(reason==REASON_REMOVE      || //      
      reason==REASON_CHARTCHANGE || //      
      reason==REASON_RECOMPILE   || //    
      reason==REASON_CHARTCLOSE  || //    
      reason==REASON_CLOSE)         //   
     {
      //---   
      DeleteScrollbar();
      //---  
      DeleteCanvas();
      //---    
      ChartSetInteger(0,CHART_MOUSE_SCROLL,true);
      //---     
      ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,false);
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---  Y  
   scrollbar_thumb_y1=(int)ObjectGetInteger(0,scrollbar_thumb_name,OBJPROP_YDISTANCE);
//---    
   ShowSymbolInfo(ThumbYCoordinateToPercent(scrollbar_thumb_y1));
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---      
   if(id==CHARTEVENT_CLICK)
     {
      //---  ,    
      ZeroScrollbarThumbVariables();
      //---  
      ChartRedraw();
      return;
     }
//---        
   if(id==CHARTEVENT_MOUSE_MOVE)
     {
      int      x      =(int)lparam; //    X
      int      y      =(int)dparam; //    Y
      int      window =WRONG_VALUE; //  ,    
      datetime time   =NULL;        // ,   X
      double   price  =0.0;         // ,   Y

      //---   
      SetSubwindowProperties();
      //---      
      CheckMouseButtonState(sparam);
      //---   
      if(ChartXYToTimePrice(0,x,y,window,time,price))
        {
         //---      
         if(window==subwindow_number)
           {
            //---    
            ChartSetInteger(0,CHART_MOUSE_SCROLL,false);
            //---  Y    
            ChartYToSubwindowY(y);
            //---     
            SetScrollbarThumbBoundaries();
            //---      
            ChangeScrollbarThumbColorOnHover(x,y);
            //---   
            SetScrollbarThumbState(x,y);
            //---    ,     
            if(scrollbar_thumb_clicked)
               MoveThumb(y);
           }
         //---      
         else
           {
            //---     
            ChartSetInteger(0,CHART_MOUSE_SCROLL,true);
            //---    ,    
            if(!scrollbar_thumb_clicked)
               SetScrollbarThumbColor(scrollbar_thumb_color);
           }
        }
      //---     
      else
        {
         //---     ,    
         if(!scrollbar_thumb_clicked)
            SetScrollbarThumbColor(scrollbar_thumb_color);
        }
      //---  
      ChartRedraw();
      return;
     }
//---      
   if(id==CHARTEVENT_CHART_CHANGE)
     {
      //---   
      SetSubwindowProperties();
      //---  Y  
      scrollbar_thumb_y1=(int)ObjectGetInteger(0,scrollbar_thumb_name,OBJPROP_YDISTANCE);
      //---     , 
      if(subwindow_height<=0)
         return;
      //---    
      ResizeCanvas();
      //---    
      AdjustScrollbarBackground();
      //---  
      AdjustScrollbarThumb();
      //---    
      ShowSymbolInfo(ThumbYCoordinateToPercent(scrollbar_thumb_y1));
      //---
      return;
     }
  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void AddCanvas()
  {
//---   ,  
   if(ObjectFind(0,canvas_name)<0)
      canvas.CreateBitmapLabel(0,subwindow_number,canvas_name,0,0,chart_width,subwindow_height,color_format);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void ResizeCanvas()
  {
//---       ,   
   if(ObjectFind(0,canvas_name)==subwindow_number)
      canvas.Resize(chart_width,subwindow_height);
//---   ,  
   else
      canvas.CreateBitmapLabel(0,subwindow_number,canvas_name,0,0,chart_width,subwindow_height,color_format);
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void DeleteCanvas()
  {
   if(ObjectFind(0,canvas_name)>0)
      canvas.Destroy();
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void SetSubwindowProperties()
  {
//---   
   subwindow_number=ChartWindowFind(0,subwindow_shortname);
//---    
   chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);
   subwindow_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,subwindow_number);
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void ShowSymbolInfo(double current_thumb_position=0.0)
  {
   int    list_lines       =0;   //     
   double thumb_position   =0.0; //         
   int    y_distance       =0;   //       
   int    line_number      =0;   //  ,     
//---  ,     
   for(int i=0; i<LIST_SIZE; i++)
     {
      //---       ,     
      if(thumb_position>=current_thumb_position)
         break;
      //---
      thumb_position+=line_size;
      line_number++;
     }
//---      
   InitializePropertyArrays(line_number);
//---  
   canvas.Erase(canvas_background_color);
//---    
   for(int i=line_number; i<LIST_SIZE; i++)
     {
      //---  
      canvas.TextOut(655,y_distance,symbol_propety_names[i]+" :",ColorToARGB(clrWhite),TA_RIGHT|TA_TOP);
      //---  
      canvas.TextOut(665,y_distance,symbol_property_values[i],ColorToARGB(symbol_property_colors[i]),TA_LEFT|TA_TOP);
      //--- c    
      y_distance+=text_height;
      //---  -  
      list_lines++;
      //---     ,  
      if(list_lines*text_height>subwindow_height)
         break;
     }
//---  
   canvas.Update();
  }
//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
void InitializePropertyArrays(int line_number)
  {
   int lines_count=0;
//---
   for(int i=line_number; i<LIST_SIZE; i++)
     {
      //---      
      symbol_property_values[i]=GetStringSymbolInfoByIndex(i);
      symbol_property_colors[i]=GetColorSymbolInfoByIndex(i);
      //---  
      lines_count++;
      //---       , 
      if(lines_count*text_height>subwindow_height)
         break;
     }
  }
//+------------------------------------------------------------------+
//|             |
//+------------------------------------------------------------------+
string GetStringSymbolInfoByIndex(int index)
  {
   string str           ="-";
   long   l_check_value =0;
   double d_check_value =0.0;
   string s_check_value ="";
//---
   switch(index)
     {
      case 0  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_SESSION_DEALS);
         str=(l_check_value==0) ? "-" : IntegerToString(l_check_value);                                  break;
      case 1  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_SESSION_BUY_ORDERS);
         str=(l_check_value==0) ? "-" : IntegerToString(l_check_value);                                  break;
      case 2  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_SESSION_SELL_ORDERS);
         str=(l_check_value==0) ? "-" : IntegerToString(l_check_value);                                  break;
      case 3  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_VOLUME);
         str=(l_check_value==0) ? "-" : IntegerToString(l_check_value);                                  break;
      case 4  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_VOLUMEHIGH);
         str=(l_check_value==0) ? "-" : IntegerToString(l_check_value);                                  break;
      case 5  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_VOLUMELOW);
         str=(l_check_value==0) ? "-" : IntegerToString(l_check_value);                                  break;
      case 6  :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_TIME);
         str=(l_check_value==0) ? "-" : TimeToString(l_check_value);                                     break;
      case 7  : str=IntegerToString(SymbolInfoInteger(_Symbol,SYMBOL_DIGITS));                           break;
      case 8  : str=IntegerToString(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));                           break;
      case 9  : str=(!SymbolInfoInteger(_Symbol,SYMBOL_SPREAD_FLOAT)) ? "false" : "true";                break;
      case 10 :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_TICKS_BOOKDEPTH);
         str=(l_check_value==0) ? "-" : DoubleToString(l_check_value,_Digits);                           break;
      case 11 : str=TradeCalcModeToString(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_CALC_MODE));            break;
      case 12 : str=TradeModeToString(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_MODE));                     break;
      case 13 :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_START_TIME);
         str=(l_check_value==0) ? "-" : TimeToString(l_check_value);                                     break;
      case 14 :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_EXPIRATION_TIME);
         str=(l_check_value==0) ? "-" : TimeToString(l_check_value);                                     break;
      case 15 :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
         str=(l_check_value==0) ? "false" : IntegerToString(l_check_value);                              break;
      case 16 :
         l_check_value=SymbolInfoInteger(_Symbol,SYMBOL_TRADE_FREEZE_LEVEL);
         str=(l_check_value==0) ? "false" : IntegerToString(l_check_value);                              break;
      case 17 : str=TradeExeModeToString(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_EXEMODE));               break;
      case 18 : str=SwapModeToString(SymbolInfoInteger(_Symbol,SYMBOL_SWAP_MODE));                       break;
      case 19 : str=WeekdayToString(SymbolInfoInteger(_Symbol,SYMBOL_SWAP_ROLLOVER3DAYS));               break;
      case 20 : str=ExpirationModeToString();                                                            break;
      case 21 : str=FillingModeToString();                                                               break;
      //---
      case 22 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_BID);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 23 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_BIDHIGH);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 24 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_BIDLOW);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 25 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 26 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_ASKHIGH);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 27 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_ASKLOW);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 28 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_LAST);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 29 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_LASTHIGH);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 30 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_LASTLOW);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,_Digits);                           break;
      case 31 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_POINT),_Digits);                      break;
      case 32 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE_PROFIT),2);          break;
      case 33 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE_LOSS),2);            break;
      case 34 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_SIZE),_Digits);            break;
      case 35 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_CONTRACT_SIZE),2);              break;
      case 36 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN),2);                       break;
      case 37 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX),2);                       break;
      case 38 : str=DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP),2);                      break;
      case 39 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_LIMIT);
         str=(d_check_value==0) ? "Unlimited" : DoubleToString(d_check_value,2);                         break;
      case 40 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SWAP_LONG);
         str=(d_check_value==0) ? "false" : DoubleToString(d_check_value,2);                             break;
      case 41 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SWAP_SHORT);
         str=(d_check_value==0) ? "false" : DoubleToString(d_check_value,2);                             break;
      case 42 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_INITIAL);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 43 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_MAINTENANCE);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 44 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_LONG);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 45 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_SHORT);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 46 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_LIMIT);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 47 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_STOP);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 48 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_MARGIN_STOPLIMIT);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 49 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_VOLUME);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 50 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_TURNOVER);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 51 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_INTEREST);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 52 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_BUY_ORDERS_VOLUME);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 53 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_SELL_ORDERS_VOLUME);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 54 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_OPEN);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 55 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_CLOSE);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 56 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_AW);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 57 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_PRICE_SETTLEMENT);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 58 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_PRICE_LIMIT_MIN);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
      case 59 :
         d_check_value=SymbolInfoDouble(_Symbol,SYMBOL_SESSION_PRICE_LIMIT_MAX);
         str=(d_check_value==0) ? "-" : DoubleToString(d_check_value,2);                                 break;
         //---
      case 60 : str=SymbolInfoString(_Symbol,SYMBOL_CURRENCY_BASE);                                      break;
      case 61 : str=SymbolInfoString(_Symbol,SYMBOL_CURRENCY_PROFIT);                                    break;
      case 62 : str=SymbolInfoString(_Symbol,SYMBOL_CURRENCY_MARGIN);                                    break;
      case 63 :
         s_check_value=SymbolInfoString(_Symbol,SYMBOL_BANK);
         str=(s_check_value!="") ? s_check_value : "-";                                                  break;
      case 64 : str=SymbolInfoString(_Symbol,SYMBOL_DESCRIPTION);                                        break;
      case 65 :
         s_check_value=SymbolInfoString(_Symbol,SYMBOL_ISIN);
         str=(s_check_value!="") ? s_check_value : "-";                                                  break;
      case 66 : str=SymbolInfoString(_Symbol,SYMBOL_PATH);                                               break;
      //---
      case 67 : str=IntegerToString(SeriesInfoInteger(_Symbol,_Period,SERIES_BARS_COUNT));               break;
      case 68 : str=TimeToString((datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_FIRSTDATE));         break;
      case 69 : str=TimeToString((datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_SERVER_FIRSTDATE));  break;
      case 70 : str=(!(bool)SeriesInfoInteger(_Symbol,_Period,SERIES_SYNCHRONIZED)) ? "false" : "true";  break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                 |
//|                             |
//+------------------------------------------------------------------+
string TradeCalcModeToString(long mode)
  {
   string str="?";
//---
   switch((ENUM_SYMBOL_CALC_MODE)mode)
     {
      case SYMBOL_CALC_MODE_FOREX               :
         str="Forex mode";          break;
      case SYMBOL_CALC_MODE_FUTURES             :
         str="Futures mode";        break;
      case SYMBOL_CALC_MODE_CFD                 :
         str="CFD mode";            break;
      case SYMBOL_CALC_MODE_CFDINDEX            :
         str="CFD index mode";      break;
      case SYMBOL_CALC_MODE_CFDLEVERAGE         :
         str="CFD Leverage mode";   break;
      case SYMBOL_CALC_MODE_EXCH_STOCKS         :
         str="Exchange mode";       break;
      case SYMBOL_CALC_MODE_EXCH_FUTURES        :
         str="Futures mode";        break;
      case SYMBOL_CALC_MODE_EXCH_FUTURES_FORTS  :
         str="FORTS Futures mode";  break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+
string TradeModeToString(long mode)
  {
   string str="-";
//---
   switch((ENUM_SYMBOL_TRADE_MODE)mode)
     {
      case SYMBOL_TRADE_MODE_DISABLED  :
         str="   ";              break;
      case SYMBOL_TRADE_MODE_LONGONLY  :
         str="  ";                   break;
      case SYMBOL_TRADE_MODE_SHORTONLY :
         str="  ";                   break;
      case SYMBOL_TRADE_MODE_CLOSEONLY :
         str="    "; break;
      case SYMBOL_TRADE_MODE_FULL      :
         str="    ";       break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|            |
//+------------------------------------------------------------------+
string TradeExeModeToString(long mode)
  {
   string str="-";
//---
   switch((ENUM_SYMBOL_TRADE_EXECUTION)mode)
     {
      case SYMBOL_TRADE_EXECUTION_REQUEST  :
         str="   (Request)";         break;
      case SYMBOL_TRADE_EXECUTION_INSTANT  :
         str="    (Instant)"; break;
      case SYMBOL_TRADE_EXECUTION_MARKET   :
         str="    (Market)";  break;
      case SYMBOL_TRADE_EXECUTION_EXCHANGE :
         str="  (Exchange)";        break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
string SwapModeToString(long mode)
  {
   string str="-";
//---
   switch((ENUM_SYMBOL_SWAP_MODE)mode)
     {
      case SYMBOL_SWAP_MODE_DISABLED         :
         str=" ";                                               break;
      case SYMBOL_SWAP_MODE_POINTS           :
         str="  ";                                    break;
      case SYMBOL_SWAP_MODE_CURRENCY_SYMBOL  :
         str="      ";           break;
      case SYMBOL_SWAP_MODE_CURRENCY_MARGIN  :
         str="      ";      break;
      case SYMBOL_SWAP_MODE_CURRENCY_DEPOSIT :
         str="      ";          break;
      case SYMBOL_SWAP_MODE_INTEREST_CURRENT :
         str="      ";      break;
      case SYMBOL_SWAP_MODE_INTEREST_OPEN    :
         str="       "; break;
      case SYMBOL_SWAP_MODE_REOPEN_CURRENT   :
         str="   (close price +/-)";      break;
      case SYMBOL_SWAP_MODE_REOPEN_BID       :
         str="   (bid price +/-)";        break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
string WeekdayToString(long day)
  {
   string str="-";
//---
   switch((ENUM_DAY_OF_WEEK)day)
     {
      case SUNDAY    :
         str="";   break;
      case MONDAY    :
         str="";   break;
      case TUESDAY   :
         str="";       break;
      case WEDNESDAY :
         str="";         break;
      case THURSDAY  :
         str="";       break;
      case FRIDAY    :
         str="";       break;
      case SATURDAY  :
         str="";       break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|            |
//+------------------------------------------------------------------+
string ExpirationModeToString()
  {
   string str="";    //   
//---    
   bool   gtc           =false; //         
   bool   day           =false; //     
   bool   specified     =false; //     
   bool   specified_day =false; //     
//---  
   gtc           =IsExpirationTypeAllowed(_Symbol,SYMBOL_EXPIRATION_GTC);
   day           =IsExpirationTypeAllowed(_Symbol,SYMBOL_EXPIRATION_DAY);
   specified     =IsExpirationTypeAllowed(_Symbol,SYMBOL_EXPIRATION_SPECIFIED);
   specified_day =IsExpirationTypeAllowed(_Symbol,SYMBOL_EXPIRATION_SPECIFIED_DAY);
//---    
   if(gtc)
     {
      StringAdd(str,"GTC");
      if(day || specified || specified_day)
         StringAdd(str," / ");
     }
//---
   if(day)
     {
      StringAdd(str,"Day");
      if(specified || specified_day)
         StringAdd(str," / ");
     }
//---
   if(specified)
     {
      StringAdd(str,"Specified");
      if(specified_day)
         StringAdd(str," / ");
     }
//---
   if(specified_day)
      StringAdd(str,"Specified Day");
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|           |
//+------------------------------------------------------------------+
string FillingModeToString()
  {
//---    
   string str="";

//---    :

//    "/"   -           ,
//                            
   bool   fok=false;

//    "/" -            , 
//                           .    , 
//                         
   bool   ioc=false;

//    ""      -            .
//                                
   bool   return_remainder=false;

//---  
   fok   =IsFillingTypeAllowed(_Symbol,SYMBOL_FILLING_FOK);
   ioc   =IsFillingTypeAllowed(_Symbol,SYMBOL_FILLING_IOC);
//---   "  "  " "
   ENUM_SYMBOL_TRADE_EXECUTION symbol_trade_exemode=(ENUM_SYMBOL_TRADE_EXECUTION)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_EXEMODE);
   return_remainder=(symbol_trade_exemode==SYMBOL_TRADE_EXECUTION_MARKET || 
                     symbol_trade_exemode==SYMBOL_TRADE_EXECUTION_EXCHANGE) ? true : false;
//---    
   if(fok)
     {
      StringAdd(str,"Fill or Kill");
      if(ioc || return_remainder)
         StringAdd(str," / ");
     }
//---
   if(ioc)
     {
      StringAdd(str,"Immediate or Cancel");
      if(return_remainder)
         StringAdd(str," / ");
     }
//---
   if(return_remainder)
      StringAdd(str,"Return");
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
bool IsExpirationTypeAllowed(string symbol,int exp_type)
  {
//---   ,      
   int expiration=(int)SymbolInfoInteger(symbol,SYMBOL_EXPIRATION_MODE);
//---  true,   exp_type 
   return((expiration&exp_type)==exp_type);
  }
//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
bool IsFillingTypeAllowed(string symbol,int fill_type)
  {
//---   ,   
   int filling=(int)SymbolInfoInteger(symbol,SYMBOL_FILLING_MODE);
//---  true,   fill_type 
   return((filling&fill_type)==fill_type);
  }
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
color GetColorSymbolInfoByIndex(int index)
  {
   double check_value =0.0;
   color  clr         =clrWhiteSmoke;
//---
   switch(index)
     {
      case 6  :
         clr=(SymbolInfoInteger(_Symbol,SYMBOL_TIME)>0) ? clrCornflowerBlue : clrWhiteSmoke;                      break;
         //---
      case 9  : clr=(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD_FLOAT)>0) ? clrGold : clrRed;                        break;
      //---
      case 13 :
         clr=(SymbolInfoInteger(_Symbol,SYMBOL_START_TIME)>0) ? clrCornflowerBlue : clrWhiteSmoke;                break;
      case 14 :
         clr=(SymbolInfoInteger(_Symbol,SYMBOL_EXPIRATION_TIME)>0) ? clrCornflowerBlue : clrWhiteSmoke;           break;
         //---
      case 15 : clr=(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL)>0) ? clrWhiteSmoke : clrRed;             break;
      case 16 : clr=(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_FREEZE_LEVEL)>0) ? clrWhiteSmoke : clrRed;            break;
      //---
      case 20 : clr=clrGold;                                                                                      break;
      case 21 : clr=clrGold;                                                                                      break;
      //---
      case 39 : clr=(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_LIMIT)>0) ? clrWhiteSmoke : clrGold;                  break;
      case 40 : clr=(SymbolInfoDouble(_Symbol,SYMBOL_SWAP_LONG)>0) ? clrLime : clrRed;                            break;
      case 41 : clr=(SymbolInfoDouble(_Symbol,SYMBOL_SWAP_SHORT)>0) ? clrLime : clrRed;                           break;
      //---
      case 60 : clr=clrGold;                                                                                      break;
      case 61 : clr=clrGold;                                                                                      break;
      case 62 : clr=clrGold;                                                                                      break;
      //---
      case 68 :
         clr=(SeriesInfoInteger(_Symbol,_Period,SERIES_FIRSTDATE)>0) ? clrCornflowerBlue : clrWhiteSmoke;         break;
      case 69 :
         clr=(SeriesInfoInteger(_Symbol,_Period,SERIES_SERVER_FIRSTDATE)>0) ? clrCornflowerBlue : clrWhiteSmoke;  break;
      case 70 : clr=(!(bool)SeriesInfoInteger(_Symbol,_Period,SERIES_SYNCHRONIZED)) ? clrRed : clrGold;           break;
     }
//---
   return(clr);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void CreateRectangleLable(long              chart_id,          // id 
                          int               sub_window,        //  
                          string            object_name,       //  
                          int               x_distance,        //  X
                          int               y_distance,        //  Y
                          int               x_size,            // 
                          int               y_size,            // 
                          ENUM_BASE_CORNER  corner,            //  
                          color             border_color,      //  
                          color             background_color,  //  
                          bool              selectable,        //   ,  FALSE
                          bool              is_on_background)  //  
  {
//---    
   if(ObjectCreate(chart_id,object_name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      //   
      ObjectSetInteger(chart_id,object_name,OBJPROP_XDISTANCE,x_distance);
      ObjectSetInteger(chart_id,object_name,OBJPROP_YDISTANCE,y_distance);
      ObjectSetInteger(chart_id,object_name,OBJPROP_XSIZE,x_size);
      ObjectSetInteger(chart_id,object_name,OBJPROP_YSIZE,y_size);
      ObjectSetInteger(chart_id,object_name,OBJPROP_BORDER_TYPE,BORDER_FLAT);    //   
      ObjectSetInteger(chart_id,object_name,OBJPROP_COLOR,border_color);
      ObjectSetInteger(chart_id,object_name,OBJPROP_CORNER,corner);
      ObjectSetInteger(chart_id,object_name,OBJPROP_BGCOLOR,background_color);
      ObjectSetInteger(chart_id,object_name,OBJPROP_SELECTABLE,selectable);
      ObjectSetInteger(chart_id,object_name,OBJPROP_BACK,is_on_background);      //  ,  true
      ObjectSetString(chart_id,object_name,OBJPROP_TOOLTIP,"\n");                //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|         |
//+------------------------------------------------------------------+
void AdjustScrollbarThumb()
  {
//---      
   CalculateScrollbarThumbHeight();
//---      ,   
   if(ObjectFind(0,scrollbar_thumb_name)>0)
     {
      //---     X
      ObjectSetInteger(0,scrollbar_thumb_name,OBJPROP_YSIZE,scrollbar_thumb_height);
      ObjectSetInteger(0,scrollbar_thumb_name,OBJPROP_XDISTANCE,chart_width-scrollbar_thumb_width);
      //---      Y,      
      if(scrollbar_thumb_y1+scrollbar_thumb_height>subwindow_height)
         ObjectSetInteger(0,scrollbar_thumb_name,OBJPROP_YDISTANCE,subwindow_height-scrollbar_thumb_height);
     }
//---  ,   
   else
     {
      CreateRectangleLable(0,subwindow_number,scrollbar_thumb_name,
                           chart_width-scrollbar_thumb_width,0,scrollbar_thumb_width,scrollbar_thumb_height,
                           CORNER_LEFT_UPPER,clrSilver,clrSilver,false,false);
     }
  }
//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
void AdjustScrollbarBackground()
  {
//---        ,   
   if(ObjectFind(0,scrollbar_background_name)>0)
     {
      //---   
      ObjectSetInteger(0,scrollbar_background_name,OBJPROP_YDISTANCE,0);
      ObjectSetInteger(0,scrollbar_background_name,OBJPROP_XDISTANCE,chart_width-scrollbar_background_width);
      ObjectSetInteger(0,scrollbar_background_name,OBJPROP_YSIZE,subwindow_height);
     }
//---   ,  
   else
     {
      CreateRectangleLable(0,subwindow_number,scrollbar_background_name,
                           chart_width-scrollbar_background_width,0,scrollbar_background_width,subwindow_height,
                           CORNER_LEFT_UPPER,scrollbar_background_color,scrollbar_background_color,false,false);
     }
  }
//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
void CalculateScrollbarThumbHeight()
  {
//---      ,   
   if(subwindow_height>=list_height)
      scrollbar_thumb_height=subwindow_height-1;
//---    
   else
     {
      double height_temp=0.0;
      //---      
      height_temp=subwindow_height-(((double)subwindow_height/100)*(100-((double)subwindow_height/list_height)*100));
      //---     25%   
      if(height_temp/subwindow_height<0.25)
         height_temp=subwindow_height/4;
      //---    
      scrollbar_thumb_height=(int)height_temp;
     }
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void DeleteScrollbar()
  {
   DeleteObjectByName(scrollbar_thumb_name);
   DeleteObjectByName(scrollbar_background_name);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteObjectByName(string object_name)
  {
//---    
   if(ObjectFind(0,object_name)>=0)
     {
      //---     ,   
      if(!ObjectDelete(0,object_name))
         Print(" ("+IntegerToString(GetLastError())+")   !");
     }
  }
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
void SetScrollbarThumbColor(color thumb_color)
  {
   ObjectSetInteger(0,scrollbar_thumb_name,OBJPROP_COLOR,thumb_color);
   ObjectSetInteger(0,scrollbar_thumb_name,OBJPROP_BGCOLOR,thumb_color);
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void SetScrollbarThumbBoundaries()
  {
   scrollbar_thumb_x1=(int)ObjectGetInteger(0,scrollbar_thumb_name,OBJPROP_XDISTANCE);
   scrollbar_thumb_y1=(int)ObjectGetInteger(0,scrollbar_thumb_name,OBJPROP_YDISTANCE);
   scrollbar_thumb_x2=scrollbar_thumb_x1+scrollbar_thumb_width;
   scrollbar_thumb_y2=scrollbar_thumb_y1+scrollbar_thumb_height;
  }
//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
void ChangeScrollbarThumbColorOnHover(int x,int y)
  {
//---        ,   
   if(x>scrollbar_thumb_x1 && x<scrollbar_thumb_x2 && y>scrollbar_thumb_y1 && y<scrollbar_thumb_x2)
      SetScrollbarThumbColor(scrollbar_thumb_color_on_hover);
//---      
   else
     {
      //---    ,    
      if(!mouse_button_state)
         SetScrollbarThumbColor(scrollbar_thumb_color);
     }
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
void SetScrollbarThumbState(int x,int y)
  {
//---        
   if(x>scrollbar_thumb_x1 && x<scrollbar_thumb_x2 && y>scrollbar_thumb_y1 && y<scrollbar_thumb_x2)
     {
      //---    ,  
      if(mouse_button_state)
         scrollbar_thumb_clicked=true;
     }
//---      
   else
     {
      //---    ,   
      if(!mouse_button_state)
         ZeroScrollbarThumbVariables();
     }
  }
//+------------------------------------------------------------------+
//|  ,               |
//+------------------------------------------------------------------+
void ZeroScrollbarThumbVariables()
  {
   scrollbar_thumb_clicked       =false;
   scrollbar_fix_point           =0;
   scrollbar_fix_point_y_offest  =0;
  }
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
void MoveThumb(int y)
  {
   int  threshold   =1; //     
   int  new_y_point =0; //   Y
//---    
   if(mouse_button_state)
     {
      //---    
      SetScrollbarThumbColor(scrollbar_thumb_color_on_click);
      //---    Y 
      if(scrollbar_fix_point==0)
         scrollbar_fix_point=y;
      //---       
      if(scrollbar_fix_point_y_offest==0)
         scrollbar_fix_point_y_offest=scrollbar_thumb_y1-scrollbar_fix_point;
     }
//---         
   if(y-scrollbar_fix_point>=threshold)
     {
      //---       
      if(scrollbar_thumb_y1+scrollbar_thumb_height+threshold<subwindow_height)
         new_y_point=y+scrollbar_fix_point_y_offest;
      else
        {
         scrollbar_fix_point_y_offest=0;
         new_y_point=int(subwindow_height-scrollbar_thumb_height)-1;
        }
      //---      
      UpdateListAndScrollbarThumb(new_y_point);
      return;
     }
//---         
   if(y-scrollbar_fix_point<=-(threshold))
     {
      //---       
      if(y-fabs(scrollbar_fix_point_y_offest)>=0)
         new_y_point=y-fabs(scrollbar_fix_point_y_offest);
      else
        {
         new_y_point=0;
         scrollbar_fix_point_y_offest=0;
        }
      //---      
      UpdateListAndScrollbarThumb(new_y_point);
      return;
     }
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void UpdateListAndScrollbarThumb(int new_point)
  {
//---   Y   
   ObjectSetInteger(0,scrollbar_thumb_name,OBJPROP_YDISTANCE,new_point);
//---         
   ShowSymbolInfo(ThumbYCoordinateToPercent(new_point));
//---   
   scrollbar_fix_point=0;
  }
//+------------------------------------------------------------------+
//|   Y                         |
//+------------------------------------------------------------------+
double ThumbYCoordinateToPercent(long y)
  {
   if(subwindow_height<=0)
      subwindow_height=1;
//---
   return(((double)y/subwindow_height)*100);
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void CheckMouseButtonState(string state)
  {
//---    
   if(state=="1")
      mouse_button_state=true;
//---    
   if(state=="0")
     {
      //---  
      ZeroScrollbarThumbVariables();
      mouse_button_state=false;
     }
  }
//+------------------------------------------------------------------+
//|   Y            |
//+------------------------------------------------------------------+
void ChartYToSubwindowY(int &y)
  {
//---        
   chart_y_offset=(int)ChartGetInteger(0,CHART_WINDOW_YDISTANCE,subwindow_number);
//---  Y    
   y-=chart_y_offset;
  }
//+------------------------------------------------------------------+
